// Lycée PEM
// Date : 8/8/2024 
// Fichier :  Blinkasm.ino
// La Led clignote avec une période T = 2s si
// r27r26 <- 0x3E8(1000)
// r25r24 <- 0xFA0 (4000)

void setup() {
  // put your setup code here, to run once
  asm("sbi 0x04,5");  // Set Bit In met le bit 5 à 1 dans le registre 0x04=DDRB
                      // equivalent à pinMode(13, output)
}

void loop() {
  // put your main code here, to run repeatedly:
  asm(
    "START:       \n"  // Etiquette de début
    "sbi 0x05,5   \n"  // Set Bit In met le bit 5 à 1 dans 0x05=PORTB
                       // Equivalent à digitalWrite(13, HIGHT)
    "rcall DELAY  \n"
    "cbi 0x05,5   \n"        // Clear bit In met le bit 5 à 0 dans 0x05=PORTB
                             // Equivalent à digitalWrite(13, LOW)
    "rcall DELAY  \n"        // Equivalent à delay(1365)
    "rjmp START   \n"        // Relative Jump recommence sans fin
                             //
    "DELAY:             \n"  // Etiquette de la temporisation
    "ldi r26,0xE8       \n"  // Charge l'octet de poid faible de delay
    "ldi r27,0x03       \n"  // Charge l'octet de poid fort de delay
    "DELAY_LOOP:        \n"
    "ldi r24,0xA0       \n"  // Charge l'octet de poid faible de delay"
    "ldi r25,0x0F       \n"  // Charge l'octet de poid fort de delay
    "DELAY_LOOP1:       \n"
    "sbiw r24, 1        \n"  // r25r24 <- r25r24 - 1
    "brne DELAY_LOOP1   \n"
    "sbiw r26,1         \n"  // r27r26 <- r27r26 - 1
    "brne DELAY_LOOP    \n"
    "ret"  // Return from subroutine
  );
}
